function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro(var1, var2, var3, var4)
nargchk(2, 4, nargin);
if nargin == 2
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro1(var1, var2);
else
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro2(var1, var2, var3, var4);
end


function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro1(userID, handles)
coordVectors = get(handles.figure1, 'UserData');
cellID = 1;
[SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro2(coordVectors.muser_x(userID), coordVectors.muser_y(userID), cellID, handles);


function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro2(x, y, cellID, handles)
PSD_dBm = -174; %dBm/Hz
awgn_N0 = (10^(PSD_dBm / 10)) / 1000;
spacing_Df = 15*10^3;
[row col] = size(x);
upper_thres = ones(row, col)*(-log(5*10^(-6))/1.5);

coordVectors = get(handles.figure1, 'UserData');

numOfFemtocells = min(size(coordVectors.femt_x, 2), size(coordVectors.femt_y, 2));
numOfMacrocells = 1;


if coordVectors.gain_calculated_m == 0
    [G, PL, numOfWalls, dist, isIndoor] = Gain_macro(x, y, 250.0, 217.0, handles);
    coordVectors = get(handles.figure1, 'UserData');
    coordVectors.Gain_m = G;
    coordVectors.PathLoss_m = PL;
    coordVectors.Walls_m = numOfWalls;
    coordVectors.distance_m = dist;
    coordVectors.isIn_m = isIndoor;
    
    coordVectors.gain_calculated_m = 1;
    set(handles.figure1, 'UserData', coordVectors);
else
    G = coordVectors.Gain_m;
    PL = coordVectors.PathLoss_m;
    numOfWalls = coordVectors.Walls_m;
    dist = coordVectors.distance_m;
    isIndoor = coordVectors.isIn_m;
end

[Pmacro Pfemto] = power_scheme(handles);

numer = Pmacro * G;

sum1 = zeros(row,col);
sum2 = 0;
coordVectors = get(handles.figure1, 'UserData');

for i=1:numOfFemtocells
    if coordVectors.gain_calculated_f(i) == 0
        G_f = Gain_femto(x, y, coordVectors.femt_x(i), coordVectors.femt_y(i), handles);
        coordVectors = get(handles.figure1, 'UserData');
        coordVectors.(genvarname(num2str(i+numOfFemtocells*5))) = G_f;
        coordVectors.gain_calculated_f(i)=1;
        set(handles.figure1, 'UserData', coordVectors);
    else
        G_f = coordVectors.(genvarname(num2str(i+numOfFemtocells*5)));
    end
    sum1 = sum1 + Pfemto(i) * G_f;
    
end


denom = awgn_N0 * spacing_Df + sum1 + sum2;
temp = numer./denom;
SINR = min(temp, upper_thres);
coordVectors = get(handles.figure1, 'UserData');
coordVectors.SINR = SINR;
set(handles.figure1, 'UserData', coordVectors);